/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : dmacmp.c

	Function       : dmacmp sample

-------------------------------------------------------------------------------
	[history]
	09-27-2010	Ver 1.00   M.Meguro    create
	07-09-2015	Ver 1.03   Y.Watanabe  device number is input by a command line argument

******************************************************************************/
//*******************************************/
//*    include                              */
//*******************************************/
#include	<stdio.h>
#include	<stdlib.h>
#include	<windows.h>
#include	<conio.h>
#include	"pcielib.h"

//#pragma warning(disable:4996)

#define		TRANSFER_MAX		(1024*1024*1024)
//#define		DMA_BUFFER_SIZE		(512*1024*1024)

HANDLE			_hDevice=(HANDLE)INVALID_HANDLE_VALUE;
unsigned char*	_tranbufw;
unsigned char*	_tranbufr;
void			*_phy=0,*_usr=0;
unsigned long	_dmasize,_transfersize;
float			_fuTime,_fPer;

int
WriteDMA(
	HANDLE	hDevice
);
int
ReadDMA(
	HANDLE	hDevice
);
int
Check(
	unsigned long	*wptr,
	unsigned long	*rptr,
	unsigned long	size
);

int
main(
	int 	argc,
	char	*argv[]
)
{
	int		ret,i,j,cnt,devnum;
	char	*stopstring;
	DWORD	*ptr;
	WORD	work[16];

	if(argc!=3)
	{
		printf("Usage:\n");
		printf("\tdmacmp [device number] [transfer max]\n");
		printf("\tdevice number:device number function\n");
		printf("\ttransfer max:transfer max size (Unit[MB])\n");
		goto EXIT;
	}
	_transfersize=strtol(argv[2],&stopstring,10);
	if(_transfersize%2!=0)
	{
		printf("͂ꂽl͋KoCgł͂܂\n");
		goto EXIT;
	}
	_transfersize*=1024*1024;
	if(_transfersize==0 || _transfersize>TRANSFER_MAX)
	{
		printf("1GB̒lł͂܂\n");
		goto EXIT;
	}
	_tranbufw=malloc(_transfersize);
	if(!_tranbufw)
	{
		printf("]obt@lł܂B\n");
		goto EXIT;
	}
	_tranbufr=malloc(_transfersize);
	if(!_tranbufr)
	{
		printf("]obt@lł܂B\n");
		goto EXIT;
	}
	devnum=strtol(argv[1],&stopstring,0);
	_hDevice=Pcie_OpenDevice(devnum);
	if(_hDevice==(HANDLE)INVALID_HANDLE_VALUE)
	{
		printf("hCoI[vł܂B\n");
		goto EXIT;
	}
	_dmasize=_transfersize;
	for(i=0;i<9;i++)
	{
		ret=Pcie_GetDMAMem(_hDevice,_dmasize,&_phy,&_usr);
		if(ret==PCIE_NORMAL)
			break;
		else
			_dmasize/=2;
		if(_dmasize==0)
			break;
	}
	if(ret!=PCIE_NORMAL)
	{
		printf("DMAlł܂B\n");
		goto EXIT;
	}
	if((_transfersize/(_dmasize/2))%2!=0)
	{
		printf("DMA]񐔂ɂȂ܂B\n");
		goto EXIT;
	}
	for(cnt=0;;cnt++)
	{	
		// nύX
		srand((unsigned)GetTickCount());
		printf("DMA]obt@TCY:%dKB\n",(int)_dmasize/1024/2);
		printf("I:ESC\n");
		printf("]f[^쐬\n");
		// œ]f[^쐬
		ptr=(DWORD*)_tranbufw;
		for(i=0;(DWORD)i<_transfersize/sizeof(work);i++)
		{
			for(j=0;j<sizeof(work)/sizeof(WORD);j++)
				work[j]=rand();
			memcpy(ptr,work,sizeof(work));
			ptr+=sizeof(work)/sizeof(DWORD);
		}
		printf("]Jn:%d\n",cnt+1);
		// DMACg
		if(WriteDMA(_hDevice)==FALSE)
		{
			printf("DMA WRITEŃG[܂\n");
			break;
		}
		// ]Ԃ\
		printf("DMA WRITE:%dus %.2fMiB/s\n",(int)_fuTime,_fPer);
		// DMA[h
		if(ReadDMA(_hDevice)==FALSE)
		{
			printf("DMA READŃG[܂\n");
			break;
		}
		// ]Ԃ\
		printf("DMA READ:%dus %.2fMiB/s\n",(int)_fuTime,_fPer);
		// f[^RyA
		if(Check((unsigned long*)_tranbufw,(unsigned long*)_tranbufr,_transfersize)==FALSE)
			break;
		printf("RyAOK\n");
		if(_kbhit())
		{
			if(_getch()==0x1b)
				break;
		}
	}
EXIT:
	if(_usr)
		Pcie_RelDMAMem(_hDevice);
	if(_hDevice!=(HANDLE)INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(_hDevice);
	if(_tranbufw)
		free(_tranbufw);
	if(_tranbufr)
		free(_tranbufr);
	return(0);
}
int
WriteDMA(
	HANDLE	hDevice
)
{
#ifdef	USE_INTR
	HANDLE	hEvent;
	int		ret;
#endif
	DWORD	value;
	int		i,dmadoneret=0;
	float	fuTime,fBytes,fPer=0;	
	LARGE_INTEGER	freq,start,end;
#ifdef	USE_INTR
	ret=Pcie_RegisterIntr(hDevice,0,0x00,0,0x00,0,0x04,0,0x10,&hEvent);
	if(ret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&start);
	// ŏ̃obt@Rs[
	memcpy((BYTE*)_usr,_tranbufw,_dmasize/2);
	for(i=0;(DWORD)i<(_transfersize/(_dmasize/2));i++)
	{
		// _uobt@ƂĎgp̂ŁAOE㔼Őݒ肷
		if(i%2==0)
			Pcie_WriteRegister32(hDevice,0,0x18,(DWORD)_phy);
		else
			Pcie_WriteRegister32(hDevice,0,0x18,(DWORD)_phy+(_dmasize/2));
		Pcie_WriteRegister32(hDevice,0,0x1C,(DWORD)0x80000000+i*(_dmasize/2));
		Pcie_WriteRegister32(hDevice,0,0x20,(DWORD)(_dmasize/2));
		Pcie_WriteRegister32(hDevice,0,0x14,(DWORD)0x80);
#ifdef	USE_INTR
		Pcie_WriteRegister32(hDevice,0,0x00,0x1011);	// start Write DMA with INTR
#else
		Pcie_WriteRegister32(hDevice,0,0x00,0x0011);	// start Write DMA
#endif
		// Ō̃CgłȂꍇ͎̓]f[^Aṽobt@ɃRs[
		if(i!=(int)(_transfersize/(_dmasize/2))-1)
		{
			if(i%2!=0)
				memcpy((BYTE*)_usr,_tranbufw+(i+1)*(_dmasize/2),_dmasize/2);
			else
				memcpy((BYTE*)_usr+_dmasize/2,_tranbufw+(i+1)*(_dmasize/2),_dmasize/2);
		}
#ifdef	USE_INTR
		dmadoneret=Pcie_IsDMADone(hDevice,hEvent,INFINITE);
		if(dmadoneret!=PCIE_NORMAL)
		{
			if(dmadoneret==PCIE_ERR_PARAM)
			{
				printf("parameter error=%d\n",dmadoneret);
			}
			else
			{
				printf("do not get dma done signal=%d\n",dmadoneret);
			}
			break;
		}
		else
		{
			Pcie_ReadRegister32(hDevice,0,0x04,&value);
			if(value & 0x10)
			{
				Pcie_WriteRegister32(hDevice,0,0x04,0x10);
			}
		}
#else
		for(;;)
		{
			Pcie_ReadRegister32(hDevice,0,0x04,&value);
			if(value & 0x10)
			{
				Pcie_WriteRegister32(hDevice,0,0x04,0x10);
				break;
			}
		}
#endif
	}
	if(dmadoneret==PCIE_NORMAL)
	{
		QueryPerformanceCounter(&end);
		fuTime=(float)((end.QuadPart-start.QuadPart)*1000000/freq.QuadPart);
		fBytes=(float)_transfersize;
		if(fuTime)
			fPer=(fBytes/fuTime);
		_fuTime=fuTime;
		_fPer=fPer;
	}
#ifdef	USE_INTR
	ret=Pcie_UnRegisterIntr(hDevice,hEvent);
	if(ret!=PCIE_NORMAL || dmadoneret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	return(TRUE);
}
int
ReadDMA(
	HANDLE	hDevice
)
{
#ifdef	USE_INTR
	HANDLE	hEvent;
	int		ret;
#endif
	DWORD	value;
	int		i,dmadoneret=0;
	float	fuTime,fBytes,fPer=0;
	LARGE_INTEGER	freq,start,end;
#ifdef	USE_INTR
	ret=Pcie_RegisterIntr(hDevice,0,0x00,0,0x00,0,0x04,0,0x10,&hEvent);
	if(ret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&start);
	for(i=0;(DWORD)i<(_transfersize/(_dmasize/2));i++)
	{
		// _uobt@ƂĎgp̂ŁAOE㔼Őݒ肷
		if(i%2==0)
			Pcie_WriteRegister32(hDevice,0,0x18,(DWORD)_phy);
		else
			Pcie_WriteRegister32(hDevice,0,0x18,(DWORD)_phy+(_dmasize/2));
		Pcie_WriteRegister32(hDevice,0,0x1C,(DWORD)0x80000000+i*(_dmasize/2));
		Pcie_WriteRegister32(hDevice,0,0x20,(DWORD)(_dmasize/2));
		Pcie_WriteRegister32(hDevice,0,0x14,(DWORD)0x80);
#ifdef	USE_INTR
		Pcie_WriteRegister32(hDevice,0,0x00,0x1001);	// start Read DMA with INTR
#else
		Pcie_WriteRegister32(hDevice,0,0x00,0x0001);	// start Read DMA
#endif
		// ԍŏ̃[hłȂꍇ͑O]f[^Aṽobt@ɃRs[
		if(i!=0)
		{
			if(i%2!=0)
				memcpy(_tranbufr+(i-1)*(_dmasize/2),(BYTE*)_usr,_dmasize/2);
			else
				memcpy(_tranbufr+(i-1)*(_dmasize/2),(BYTE*)_usr+_dmasize/2,_dmasize/2);
		}
#ifdef	USE_INTR
		dmadoneret=Pcie_IsDMADone(hDevice,hEvent,INFINITE);
		if(dmadoneret!=PCIE_NORMAL)
		{
			if(dmadoneret==PCIE_ERR_PARAM)
			{
				printf("parameter error=%d\n",dmadoneret);
			}
			else
			{
				printf("do not get dma done signal=%d\n",dmadoneret);
			}
			break;
		}
		else
		{
			Pcie_ReadRegister32(hDevice,0,0x04,&value);
			if(value & 0x10)
			{
				Pcie_WriteRegister32(hDevice,0,0x04,0x10);
			}
		}
#else
		for(;;)
		{
			Pcie_ReadRegister32(hDevice,0,0x04,&value);
			if(value & 0x10)
			{
				Pcie_WriteRegister32(hDevice,0,0x04,0x10);
				break;
			}
		}
#endif
	}
	if(dmadoneret==PCIE_NORMAL)
	{
		// Ō̃obt@Rs[
		memcpy(_tranbufr+(i-1)*(_dmasize/2),(BYTE*)_usr+_dmasize/2,_dmasize/2);
		QueryPerformanceCounter(&end);
		fuTime=(float)((end.QuadPart-start.QuadPart)*1000000/freq.QuadPart);
		fBytes=(float)_transfersize;
		if(fuTime)
			fPer=(fBytes/fuTime);
		_fuTime=fuTime;
		_fPer=fPer;
	}
#ifdef	USE_INTR
	ret=Pcie_UnRegisterIntr(hDevice,hEvent);
	if(ret!=PCIE_NORMAL || dmadoneret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	return(TRUE);
}
int
Check(
	unsigned long	*wptr,
	unsigned long	*rptr,
	unsigned long	size
)
{
	int			i;

	for(i=0;i<(int)size/sizeof(long);i++,wptr++,rptr++)
	{
		if(*wptr!=*rptr)
		{
			printf("f[^słB offset:0x%08x write=0x%08x read=0x%08x\n",i*4,(DWORD)*wptr,(DWORD)*rptr);
			return(FALSE);
		}
	}
	return(TRUE);
}
