#include	<windows.h>
#include	<stdio.h>
#include	<process.h>
#include	<shlwapi.h>
#include	"pcielib.h"
#include	"resource.h"

#pragma warning(disable:4996)

//#define		TRANSFER_MAX		(512*1024*1024)
//#define		DMA_BUFFER_SIZE		(256*1024*1024)

#define		EVENT_NAME			"DMAEVENT"
#define		WM_SENDSTART		(WM_APP+0)
#define		WM_SENDSTOP			(WM_APP+1)
#define		WM_RECVSTOP			(WM_APP+2)
#define		WM_FILESAVE_START	(WM_APP+3)
#define		WM_FILESAVE_STOP	(WM_APP+4)
#define		OPTION_ELEMENT		'/'

#define	PCIE_LINK		(0x0000005C)
#define		NO_LINK			(0x8000)	// No Link
#define		LINK_GEN2		(0x0004)	// GEN2
#define		LINK_1LANE		(0x0000)	// 1-LANE
#define		LINK_2LANE		(0x0001)	// 2-LANE
#define		LINK_4LANE		(0x0002)	// 4-LANE
#define		LINK_8LANE		(0x0003)	// 8-LANE

//#define		USE_INTR

typedef	struct
{
	HWND			hWnd;
	HANDLE			hDevice;
	HANDLE			hEvent;
	unsigned long	stop;
	unsigned char*	tranbuf;
	unsigned long	bufsize;
	unsigned long	status;
	unsigned long	hw_spec;
	float			fuTime;
	float			fPer;
	BYTE			szFile[MAX_PATH];
}THREADARG;

HINSTANCE		_hInst;
HANDLE			_hDevice=(HANDLE)INVALID_HANDLE_VALUE;
HANDLE			_hEvent;
THREADARG		_RecvArg,_SaveArg,_LoadArg,_SendArg;
OVERLAPPED		_tOverLap;
unsigned char*	_tranbuf;
void			*_phy,*_usr;
unsigned long	_tarnsfer_max;
unsigned long	_dmasize;

static	int		_optind=1;
static	char	*_optarg=(char*)NULL;
HWND			_hDlgWnd;

int	WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPreInst,
	LPSTR		lpszCmdLine,
	int			nCmdShow
);
LRESULT	CALLBACK
MainProc(
	HWND	hDlg,			/* _CAO{bNXEBhẼnh */
	UINT	message,		/* bZ[W̃^Cv					  */
	WPARAM	wParam,			/* bZ[WŗL̏					  */
	LPARAM	lParam			/* bZ[WŗL̏					  */
);
LRESULT	CALLBACK
MainProc2(
	HWND	hDlg,			/* _CAO{bNXEBhẼnh */
	UINT	message,		/* bZ[W̃^Cv					  */
	WPARAM	wParam,			/* bZ[WŗL̏					  */
	LPARAM	lParam			/* bZ[WŗL̏					  */
);
void
SetWinCenter(
	HWND	hWnd
);
void
LoadThreadMain(
	void	*context
);
void
SendThreadMain(
	void	*context
);
void
RecvThreadMain(
	void	*arg
);
void
EnableButton(
	HWND	hDlg
);
void
DisableButton(
	HWND	hDlg
);
void
SaveFileThreadMain(
	void	*context
);
BOOL
FileOpen(
	HWND	hWnd,
	BYTE	*file
);
void
ChangeFileName(
	BYTE	*file
);
void
IncFileName(
	BYTE	*file
);
int
Check(
	void	*context
);
unsigned long
cpu_to_be32(
	unsigned long	value
);

#ifdef _WIN64
#undef GWL_HINSTANCE
#define GWL_HINSTANCE GWLP_HINSTANCE
#undef GetWindowLong
#define GetWindowLong GetWindowLongPtr
#endif

void
LinkDisplay(
	void
)
{
	unsigned long	pcie_link;
	unsigned char	work[256];

	Pcie_ReadRegister32(_hDevice,0,PCIE_LINK,&pcie_link);
	if(pcie_link & NO_LINK)
		wsprintf(work,"Link Status:No Link\r\n");
	else
	{
		if(pcie_link & LINK_GEN2)
		{
			if((pcie_link & 0x03)==LINK_8LANE)
				wsprintf(work,"Link Status:Gen2 8-Lane\r\n");
			else if((pcie_link & 0x03)==LINK_4LANE)
				wsprintf(work,"Link Status:Gen2 4-Lane\r\n");
			else if((pcie_link & 0x03)==LINK_2LANE)
				wsprintf(work,"Link Status:Gen2 2-Lane\r\n");
			else
				wsprintf(work,"Link Status:Gen2 1-Lane\r\n");
		}
		else
		{
			if((pcie_link & 0x03)==LINK_8LANE)
				wsprintf(work,"Link Status:Gen1 8-Lane\r\n");
			else if((pcie_link & 0x03)==LINK_4LANE)
				wsprintf(work,"Link Status:Gen1 4-Lane\r\n");
			else if((pcie_link & 0x03)==LINK_2LANE)
				wsprintf(work,"Link Status:Gen1 2-Lane\r\n");
			else
				wsprintf(work,"Link Status:Gen1 1-Lane\r\n");
		}
	}
	SetDlgItemText(_hDlgWnd,IDC_STATIC_LINK,work);
}
void
ShowDeviceImageBMP(
	HWND	hWnd,
	HDC		hdc,
	int		id
)
{
	HDC						hmdc;
	HBITMAP					hBitmap;
	BITMAP					bmp;
	HINSTANCE				hInst;
	int						BMP_W, BMP_H;

	hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	// t@C΃foCXC[WBMPt@C烍[h
	if(PathFileExists("board.bmp"))
		hBitmap = (HBITMAP)LoadImage( NULL, (LPCTSTR)"board.bmp", IMAGE_BITMAP,
									0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION );
	else
		hBitmap = LoadBitmap(hInst, MAKEINTRESOURCE(id));
	GetObject(hBitmap, sizeof(BITMAP), &bmp);
	BMP_W = (int)bmp.bmWidth;
	BMP_H = (int)bmp.bmHeight;
	hmdc = CreateCompatibleDC(hdc);
	SelectObject(hmdc, hBitmap);
	BitBlt(hdc, 0, 0, BMP_W, BMP_H, hmdc, 0, 0, SRCCOPY);
	DeleteDC(hmdc);
	DeleteObject(hBitmap);
}
char**
InitWinGetOpt(
	int		*argc
)
{
	// for UNICODE
//	LPWSTR *argv = CommandLineToArgvW(GetCommandLineW(), &argc);
	_optind=1;
	_optarg=(char*)NULL;
	if(argc)
		*argc=__argc;
	return(__argv);
}
int
WinGetOpt(
	int		argc,
	char	*argv[],
	LPSTR	lpszOpt
)
{
	int		i,ret=(int)'?',ind;

	if(_optind<argc)
	{
		for(i=0;i<lstrlen(lpszOpt);i++)
		{
			if(argv[_optind][0]==(char)OPTION_ELEMENT &&
				argv[_optind][1]==lpszOpt[i])
			{
				ind=_optind;
				// IvV
				if(lpszOpt[i+1]==':')
				{
					// ̃IvVɑĈi[Ă
					// /aXXXX
					if(lstrlen(argv[_optind])>2)
					{
						_optarg=&argv[_optind][2];
					}
					// ̈IvV
					// /a XXXX
					else
					{
						++_optind;
						if(_optind<argc)
							_optarg=argv[_optind];
						else
						{
							ret=(int)':';
							goto EXIT;
						}
					}
				}
				else
					_optarg=(char*)NULL;
				++_optind;
				return(argv[ind][1]);
			}
			else if(argv[_optind][0]!=(char)OPTION_ELEMENT)
				return((int)-1);
		}
		++_optind;
	}
	else
	{
		// ͏I
		ret=(int)-1;
	}
EXIT:
	return(ret);
}
char*
GetOptArg(
	void
)
{
	return(_optarg);
}
int
GetOptind(
	void
)
{
	return(_optind);
}
int	WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPreInst,
	LPSTR		lpszCmdLine,
	int			nCmdShow
)
{
	int		ret,i;
	char	**argv;
	int		argc,result;
	char	*ptr;
	BYTE	szDir[256];
	DWORD	regad,paysize;

	// INIt@C擾
	GetCurrentDirectory(sizeof(szDir),(LPSTR)szDir);
	lstrcat((LPSTR)szDir,"\\dmatpgui.ini");
	_tarnsfer_max=GetPrivateProfileInt("FPGA","DDR_SIZE",0x20000000,(LPSTR)szDir);
	regad=GetPrivateProfileInt("FPGA","MAX_PAYLOAD_REGAD",0x14,(LPSTR)szDir);
	paysize=GetPrivateProfileInt("FPGA","MAX_PAYLOAD_SIZE",128,(LPSTR)szDir);

	_hInst=hInstance;
	_dmasize=_tarnsfer_max/2;
	argv=InitWinGetOpt(&argc);
	while((result=WinGetOpt(argc,argv,"s:"))!=-1)
	{
		switch(result)
		{
			case 's':
				ptr=GetOptArg();
				_dmasize=atoi(ptr)*1024*2;
				break;
		}
	}
	for(;;)
	{
		_hEvent=CreateEvent(NULL,TRUE,TRUE,EVENT_NAME);
		if(!_hEvent)
		{
			MessageBox(NULL,"Can not Create Event.\r\n","error",MB_OK);
			break;
		}
		_tranbuf=VirtualAlloc(NULL,_tarnsfer_max,MEM_COMMIT,PAGE_READWRITE);
		if(!_tranbuf)
		{
			MessageBox(NULL,"Can not allocate transfer buffer.\r\n","error",MB_OK);
			break;
		}
		_hDevice=Pcie_OpenDevice(0);
		if(_hDevice==(HANDLE)INVALID_HANDLE_VALUE)
		{
			MessageBox(NULL,"Can not open the driver.\r\n","error",MB_OK);
			break;
		}
		Pcie_WriteRegister32(_hDevice,0,regad,(DWORD)paysize);
		for(i=0;i<9;i++)
		{
			ret=Pcie_GetDMAMem(_hDevice,_dmasize,&_phy,&_usr);
			if(ret==PCIE_NORMAL)
				break;
			else
				_dmasize/=2;
			if(_dmasize==0)
				break;
		}
		if(ret!=PCIE_NORMAL)
		{
			MessageBox(NULL,"Can not allocate DMA buffer.\r\n","error",MB_OK);
			break;
		}
		DialogBox(_hInst,"MAINBOX",NULL,(DLGPROC)MainProc);
		break;
	}
	if(_hEvent)
		CloseHandle(_hEvent);
	if(_tranbuf)
		VirtualFree((LPVOID)_tranbuf,0,MEM_RELEASE);
	return(0);
}
LRESULT	CALLBACK
MainProc(
	HWND	hDlg,			/* _CAO{bNXEBhẼnh */
	UINT	message,		/* bZ[W̃^Cv					  */
	WPARAM	wParam,			/* bZ[WŗL̏					  */
	LPARAM	lParam			/* bZ[WŗL̏					  */
)
{
	BYTE		work[64];
	BYTE		szFile[MAX_PATH];
	DWORD		gen,clock;
	float		fuTime,fPer;
	int			cnt;
	static	int	bt=0;
    switch(message)
	{
		case WM_INITDIALOG:					/* _CAO{bNX */
			SetWinCenter(hDlg);
			SetDlgItemText(hDlg,IDC_EDIT_RECVFILE,"C:\\temp\\Test0000.dat");
			wsprintf(work,"DMA Buffer Size:%dKiB",_dmasize/1024/2);
			SetDlgItemText(hDlg,IDC_STATIC_DMA,work);
			return (TRUE);
		case WM_FILESAVE_START:
			_SaveArg.hEvent=OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENT_NAME);
			ResetEvent(_SaveArg.hEvent);
			_SaveArg.hWnd=hDlg;
			_SaveArg.bufsize=_tarnsfer_max;
			_SaveArg.tranbuf=(LPVOID)wParam;
			GetDlgItemText(hDlg,IDC_EDIT_RECVFILE,_SaveArg.szFile,sizeof(_SaveArg.szFile)-1);
			ChangeFileName(_SaveArg.szFile);
			SetDlgItemText(hDlg,IDC_EDIT_RECVFILE,_SaveArg.szFile);
			_beginthread(SaveFileThreadMain,0,&_SaveArg);
			return (TRUE);
		case WM_FILESAVE_STOP:
			IncFileName(_SaveArg.szFile);
			SetDlgItemText(hDlg,IDC_EDIT_RECVFILE,_SaveArg.szFile);
			return (TRUE);
		case WM_SENDSTART:
			if(_LoadArg.stop==0)
			{
				if(lstrlen(_LoadArg.szFile))
				{
					IncFileName(_LoadArg.szFile);
					SetDlgItemText(hDlg,IDC_EDIT_SENDFILE,_LoadArg.szFile);
				}
				_SendArg.hEvent=OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENT_NAME);
				ResetEvent(_SendArg.hEvent);
				_SendArg.hw_spec=1;
				if(IsDlgButtonChecked(hDlg,IDC_CHECK_HW)==BST_CHECKED)
					_SendArg.hw_spec=0;
				_SendArg.hWnd=hDlg;
				_SendArg.hDevice=_hDevice;
				_SendArg.stop=0;
				_SendArg.bufsize=_tarnsfer_max;
				_SendArg.tranbuf=(LPVOID)_LoadArg.tranbuf;
				_beginthread(SendThreadMain,0,&_SendArg);
			}
			else
			{
				EnableButton(hDlg);
			}
			return (TRUE);
		case WM_SENDSTOP:
			if(_SendArg.status)
			{
				MessageBox(hDlg,"Error! Stop the thread.\r\n","error",MB_OK);
				EnableButton(hDlg);
			}
			else if(_SendArg.stop)
			{
				EnableButton(hDlg);
			}
			else
			{
				sprintf(work,"DMA WRITE:%ldus %.2fMiB/s",(int)_SendArg.fuTime,_SendArg.fPer);
				SetDlgItemText(hDlg,IDC_STATIC_DMA_READ,work);
				Pcie_ReadRegister32(_hDevice,0,0x5c,&gen);
				Pcie_ReadRegister32(_hDevice,0,0x58,&clock);
				// GEN2
				if(gen & 0x04)
				{
					fuTime=(float)(clock*4);
				}
				else
				{
					fuTime=(float)(clock*8);
				}
				fuTime/=1000;
				fPer=(float)(_dmasize/2);
				fPer/=fuTime;
				sprintf(work,"HW_SPEC:%ldus %.2fMiB/s",(int)fuTime,fPer);
				SetDlgItemText(hDlg,IDC_STATIC_DMA_HW,work);
				if(GetDlgItemText(hDlg,IDC_EDIT_SENDCNT,work,sizeof(work)-1))
				{
					cnt=atoi(work)-1;
					wsprintf(work,"%d",cnt);
					SetDlgItemText(hDlg,IDC_EDIT_SENDCNT,work);
					if(cnt>0)
					{
						PostMessage(hDlg,WM_COMMAND,(WPARAM)IDC_BUTTON_SENDSTART,(LPARAM)0);
					}
					else
					{
						EnableButton(hDlg);
					}
				}
			}
			return (TRUE);
		case WM_RECVSTOP:
			if(_RecvArg.status)
			{
				MessageBox(hDlg,"Error! Stop the thread.\r\n","error",MB_OK);
				EnableButton(hDlg);
			}
			else if(_RecvArg.stop)
			{
				EnableButton(hDlg);
			}
			else
			{
				sprintf(work,"DMA READ:%ldus %.2fMiB/s",(int)_RecvArg.fuTime,_RecvArg.fPer);
				SetDlgItemText(hDlg,IDC_STATIC_DMA_READ,work);
				SetDlgItemText(_hDlgWnd,IDC_STATIC_DMA_READ,work);
				Pcie_ReadRegister32(_hDevice,0,0x5c,&gen);
				Pcie_ReadRegister32(_hDevice,0,0x58,&clock);
				// GEN2
				if(gen & 0x04)
				{
					fuTime=(float)(clock*4);
				}
				else
				{
					fuTime=(float)(clock*8);
				}
				fuTime/=1000;
				fPer=(float)(_dmasize/2);
				fPer/=fuTime;
				sprintf(work,"HW_SPEC:%ldus %.2fMiB/s",(int)fuTime,fPer);
				SetDlgItemText(hDlg,IDC_STATIC_DMA_HW,work);
				SetDlgItemText(_hDlgWnd,IDC_STATIC_DMA_HW,work);
				if(IsDlgButtonChecked(hDlg,IDC_CHECK_SAVE)==BST_CHECKED)
				{
					PostMessage(hDlg,WM_FILESAVE_START,(WPARAM)_RecvArg.tranbuf,(LPARAM)0);
				}
				if(IsDlgButtonChecked(hDlg,IDC_CHECK_VERIFY)==BST_CHECKED)
				{
					if(Check(&_RecvArg)==FALSE)
					{
						DestroyWindow(_hDlgWnd);
						_hDlgWnd=0;
						EnableButton(hDlg);
						return (TRUE);
					}
				}
				if(GetDlgItemText(hDlg,IDC_EDIT_RECVCNT,work,sizeof(work)-1))
				{
					cnt=atoi(work)-1;
					wsprintf(work,"%d",cnt);
					SetDlgItemText(hDlg,IDC_EDIT_RECVCNT,work);
					if(cnt>0)
					{
						PostMessage(hDlg,WM_COMMAND,(WPARAM)IDC_BUTTON_RECVSTART,(LPARAM)0);
					}
					else
					{
						MessageBox(hDlg,"Complete.\r\n","OK",MB_OK);
						DestroyWindow(_hDlgWnd);
						_hDlgWnd=0;
						EnableButton(hDlg);
					}
				}
			}
			return (TRUE);
		case WM_COMMAND:					/* R}h󂯎 */
			switch(LOWORD(wParam))
			{
				case IDC_BUTTON_SENDSTART:
					{
						DWORD	*ptr=(DWORD*)_tranbuf;
						int		i;

						for(i=0;i<(int)_tarnsfer_max/4;i++)
						{
							*ptr++=cpu_to_be32(i);
						}
					}
					if(GetDlgItemText(hDlg,IDC_EDIT_SENDCNT,work,sizeof(work)-1)==0 || atoi(work)<=0)
						return(TRUE);
					_LoadArg.hWnd=hDlg;
					_LoadArg.hDevice=_hDevice;
					_LoadArg.stop=0;
					_LoadArg.status=0;
					if(GetDlgItemText(hDlg,IDC_EDIT_SENDFILE,_LoadArg.szFile,sizeof(_LoadArg.szFile)-1))
					{
						ChangeFileName(_LoadArg.szFile);
						SetDlgItemText(hDlg,IDC_EDIT_SENDFILE,_LoadArg.szFile);
					}
					else
						_LoadArg.szFile[0]=(BYTE)NULL;
					DisableButton(hDlg);
					_beginthread(LoadThreadMain,0,&_LoadArg);
					return(TRUE);
				case IDC_BUTTON_RECVSTART:
					if(GetDlgItemText(hDlg,IDC_EDIT_RECVCNT,work,sizeof(work)-1)==0 || atoi(work)<=0)
						return(TRUE);
					if(_hDlgWnd==NULL)
					{
						_hDlgWnd=CreateDialog(_hInst,"SUBBOX",hDlg,(DLGPROC)MainProc2);
						if(_hDlgWnd==NULL)
							return(FALSE);
						ShowWindow(_hDlgWnd,SW_SHOW);
						LinkDisplay();
						UpdateWindow(_hDlgWnd);
					}
					_RecvArg.hw_spec=1;
					if(IsDlgButtonChecked(hDlg,IDC_CHECK_HW)==BST_CHECKED)
						_RecvArg.hw_spec=0;
					_RecvArg.hWnd=hDlg;
					_RecvArg.hDevice=_hDevice;
					DisableButton(hDlg);
					_RecvArg.stop=0;
					_RecvArg.status=0;
					_beginthread(RecvThreadMain,0,&_RecvArg);
					return(TRUE);
				case IDC_CHECK_SAVE:
					if(IsDlgButtonChecked(hDlg,IDC_CHECK_SAVE)==BST_CHECKED)
					{
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RECVFILE),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RECVFILE),TRUE);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RECVFILE),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RECVFILE),FALSE);
					}
					return(TRUE);
				case IDC_BUTTON_SENDFILE:
					if(FileOpen(hDlg,szFile))
						SetDlgItemText(hDlg,IDC_EDIT_SENDFILE,szFile);
					return(TRUE);
				case IDC_BUTTON_RECVFILE:
					if(FileOpen(hDlg,szFile))
						SetDlgItemText(hDlg,IDC_EDIT_RECVFILE,szFile);
					return(TRUE);
				case IDOK:
				case IDCANCEL:
					WaitForSingleObject(_hEvent,INFINITE);
					Pcie_RelDMAMem(_hDevice);
					// foCX
					if(_hDevice!=(HANDLE)INVALID_HANDLE_VALUE)
						Pcie_CloseDevice(_hDevice);
					EndDialog(hDlg,TRUE);	/* _CAO{bNX */
					return(TRUE);
			}
			break;
	}
	return(FALSE);							/* bZ[WȂꍇ */
}
LRESULT	CALLBACK
MainProc2(
	HWND	hDlg,			/* _CAO{bNXEBhẼnh */
	UINT	message,		/* bZ[W̃^Cv					  */
	WPARAM	wParam,			/* bZ[WŗL̏					  */
	LPARAM	lParam			/* bZ[WŗL̏					  */
)
{
	HDC			hdc;
	PAINTSTRUCT	ps;
	switch(message)
	{
		case WM_INITDIALOG:					/* _CAO{bNX */
			SetWinCenter(hDlg);
			return (TRUE);
		case WM_PAINT :
			hdc=BeginPaint(hDlg, &ps);
			ShowDeviceImageBMP(hDlg,hdc,IDB_BITMAP1);
			EndPaint(hDlg,&ps);
			return(TRUE);
		case WM_COMMAND:					/* R}h󂯎 */
			switch(LOWORD(wParam))
			{
				case IDOK:
				case IDCANCEL:
					EndDialog(hDlg,TRUE);	/* _CAO{bNX */
					return(TRUE);
			}
			break;
	}
	return(FALSE);							/* bZ[WȂꍇ */
}
void
SetWinCenter(
	HWND	hWnd
)
{
	HWND	hDeskWnd;
	RECT	deskrc,rc;
	int		x,y;
    
	hDeskWnd=GetDesktopWindow();
	GetWindowRect(hDeskWnd,(LPRECT)&deskrc);
	GetWindowRect(hWnd,(LPRECT)&rc);
	x=(deskrc.right-(rc.right-rc.left))/2;
	y=(deskrc.bottom-(rc.bottom-rc.top))/2;
	SetWindowPos(hWnd,HWND_TOP,x,y,(rc.right-rc.left),(rc.bottom-rc.top),SWP_SHOWWINDOW); 
}
void
LoadThreadMain(
	void	*context
)
{
	THREADARG	*arg=(THREADARG*)context;
	FILE		*fp;
	DWORD		size,i;

	arg->status=0;
	arg->hEvent=OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENT_NAME);
	WaitForSingleObject(arg->hEvent,INFINITE);
	arg->tranbuf=_tranbuf;
	arg->bufsize=_tarnsfer_max;

	if(lstrlen(arg->szFile))
	{
		fp=fopen(arg->szFile,"rb");
		if(fp)
		{
			size=0;
			for(i=0;i<arg->bufsize/(_dmasize/2);i++)
			{
				if(arg->stop)
					break;
				fread(&arg->tranbuf[size],1,(_dmasize/2),fp);
				size+=(_dmasize/2);
			}
			fclose(fp);
		}
	}
	PostMessage(arg->hWnd,WM_SENDSTART,(WPARAM)0,(LPARAM)0);
	_endthread();
}
int
WriteDMA(
	THREADARG	*arg
)
{
#ifdef	USE_INTR
	HANDLE	hEvent;
	int		ret;
#endif
	DWORD	value;
	int		i;
	LARGE_INTEGER	freq,start,end;
	float			fuTime,fBytes,fPer=0;

#ifdef	USE_INTR
	ret=Pcie_RegisterIntr(arg->hDevice,0,0x00,0,0x00,0,0x04,0,0x11,&hEvent);
	if(ret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&start);
	if(arg->hw_spec & 1)
	{
		// ŏ̃obt@Rs[
		memcpy((BYTE*)_usr,arg->tranbuf,_dmasize/2);
	}
	for(i=0;i<(int)(_tarnsfer_max/(_dmasize/2));i++)
	{
		// _uobt@ƂĎgp̂ŁAOE㔼Őݒ肷
		if(i%2==0)
			Pcie_WriteRegister32(arg->hDevice,0,0x18,(DWORD)_phy);
		else
			Pcie_WriteRegister32(arg->hDevice,0,0x18,(DWORD)_phy+(_dmasize/2));
		Pcie_WriteRegister32(arg->hDevice,0,0x1C,(DWORD)0x80000000+i*(_dmasize/2));
		Pcie_WriteRegister32(arg->hDevice,0,0x20,(DWORD)(_dmasize/2));
//		Pcie_WriteRegister32(arg->hDevice,0,0x14,(DWORD)0x80);
#ifdef	USE_INTR
		Pcie_WriteRegister32(arg->hDevice,0,0x00,0x1011);	// start Write DMA with INTR
#else
		Pcie_WriteRegister32(arg->hDevice,0,0x00,0x0011);	// start Write DMA
#endif

		if(arg->hw_spec & 1)
		{
			// Ō̃CgłȂꍇ͎̓]f[^Aṽobt@ɃRs[
			if(i!=(int)(_tarnsfer_max/(_dmasize/2))-1)
			{
				if(i%2!=0)
					memcpy((BYTE*)_usr,arg->tranbuf+(i+1)*(_dmasize/2),_dmasize/2);
//					memcpy(arg->tranbuf+(i+1)*(_dmasize/2),(BYTE*)_usr,_dmasize/2);
				else
					memcpy((BYTE*)_usr+_dmasize/2,arg->tranbuf+(i+1)*(_dmasize/2),_dmasize/2);
//					memcpy(arg->tranbuf+(i+1)*(_dmasize/2),(BYTE*)_usr+_dmasize/2,_dmasize/2);
			}
		}
#ifdef	USE_INTR
		Pcie_IsDMADone(arg->hDevice,hEvent,INFINITE);
		Pcie_ReadRegister32(arg->hDevice,0,0x04,&value);
		Pcie_WriteRegister32(arg->hDevice,0,0x04,0x10);
#else
		for(;;)
		{
			Pcie_ReadRegister32(arg->hDevice,0,0x04,&value);
			if(value & 0x10)
			{
				Pcie_WriteRegister32(arg->hDevice,0,0x04,0x10);
				break;
			}
		}
#endif
	}
	QueryPerformanceCounter(&end);
	fuTime=(float)((end.QuadPart-start.QuadPart)*1000000/freq.QuadPart);
	fBytes=(float)_tarnsfer_max;
	if(fuTime)
		fPer=(fBytes/fuTime);
	arg->fuTime=fuTime;
	arg->fPer=fPer;
#ifdef	USE_INTR
	ret=Pcie_UnRegisterIntr(arg->hDevice,hEvent);
	if(ret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	return(TRUE);
}
void
SendThreadMain(
	void	*context
)
{
	THREADARG		*arg=(THREADARG*)context;

	arg->status=0;
	arg->bufsize=_tarnsfer_max;
	for(;;)
	{
		if(WriteDMA(arg)!=TRUE)
		{
			if(arg->stop==0)
				arg->status=1;
			break;
		}
		break;
	}
	SetEvent(arg->hEvent);
	PostMessage(arg->hWnd,WM_SENDSTOP,(WPARAM)0,(LPARAM)0);
	_endthread();
}
int
ReadDMA(
	THREADARG	*arg
)
{
#ifdef	USE_INTR
	HANDLE	hEvent;
	int		ret;
#endif
	DWORD	value;
	int		i;
	LARGE_INTEGER	freq,start,end;
	float			fuTime,fBytes,fPer=0;

#ifdef	USE_INTR
	ret=Pcie_RegisterIntr(arg->hDevice,0,0x00,0,0x00,0,0x04,0,0x11,&hEvent);
	if(ret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&start);
	for(i=0;i<(int)(_tarnsfer_max/(_dmasize/2));i++)
	{
		// _uobt@ƂĎgp̂ŁAOE㔼Őݒ肷
		if(i%2==0)
			Pcie_WriteRegister32(arg->hDevice,0,0x18,(DWORD)_phy);
		else
			Pcie_WriteRegister32(arg->hDevice,0,0x18,(DWORD)_phy+(_dmasize/2));
		Pcie_WriteRegister32(arg->hDevice,0,0x1C,(DWORD)0x80000000+i*(_dmasize/2));
		Pcie_WriteRegister32(arg->hDevice,0,0x20,(DWORD)(_dmasize/2));
//		Pcie_WriteRegister32(arg->hDevice,0,0x14,(DWORD)0x80);
#ifdef	USE_INTR
		Pcie_WriteRegister32(arg->hDevice,0,0x00,0x1001);	// start Read DMA with INTR
#else
		Pcie_WriteRegister32(arg->hDevice,0,0x00,0x0001);	// start Read DMA
#endif

		if(arg->hw_spec & 1)
		{
			// ԍŏ̃[hłȂꍇ͑O]f[^Aṽobt@ɃRs[
			if(i!=0)
			{
				if(i%2!=0)
					memcpy(arg->tranbuf+(i-1)*(_dmasize/2),(BYTE*)_usr,_dmasize/2);
				else
					memcpy(arg->tranbuf+(i-1)*(_dmasize/2),(BYTE*)_usr+_dmasize/2,_dmasize/2);
			}
		}
#ifdef	USE_INTR
		Pcie_IsDMADone(arg->hDevice,hEvent,INFINITE);
		Pcie_ReadRegister32(arg->hDevice,0,0x04,&value);
		Pcie_WriteRegister32(arg->hDevice,0,0x04,0x10);
#else
		for(;;)
		{
			Pcie_ReadRegister32(arg->hDevice,0,0x04,&value);
			if(value & 0x10)
			{
				Pcie_WriteRegister32(arg->hDevice,0,0x04,0x10);
				break;
			}
		}
#endif
	}
	if(arg->hw_spec & 1)
	{
		// Ō̃obt@Rs[
		memcpy(arg->tranbuf+(i-1)*(_dmasize/2),(BYTE*)_usr+_dmasize/2,_dmasize/2);
	}
	QueryPerformanceCounter(&end);
	fuTime=(float)((end.QuadPart-start.QuadPart)*1000000/freq.QuadPart);
	fBytes=(float)_tarnsfer_max;
	if(fuTime)
		fPer=(fBytes/fuTime);
	arg->fuTime=fuTime;
	arg->fPer=fPer;
#ifdef	USE_INTR
	ret=Pcie_UnRegisterIntr(arg->hDevice,hEvent);
	if(ret!=PCIE_NORMAL)
	{
		return(FALSE);
	}
#endif
	return(TRUE);
}
void
RecvThreadMain(
	void	*context
)
{
	THREADARG		*arg=(THREADARG*)context;

	arg->status=0;
	arg->hEvent=OpenEvent(EVENT_ALL_ACCESS,FALSE,EVENT_NAME);
	WaitForSingleObject(arg->hEvent,INFINITE);
	arg->tranbuf=_tranbuf;
	arg->bufsize=_tarnsfer_max;
	for(;;)
	{
		if(ReadDMA(arg)!=TRUE)
		{
			if(arg->stop==0)
				arg->status=1;
			break;
		}
		break;
	}
	PostMessage(arg->hWnd,WM_RECVSTOP,(WPARAM)0,(LPARAM)0);
	_endthread();
}
void
EnableButton(
	HWND	hDlg
)
{
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_SENDFILE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_SENDFILE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_SENDSTART),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RECVSTART),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_CHECK_SAVE),TRUE);
	if(IsDlgButtonChecked(hDlg,IDC_CHECK_SAVE)==BST_CHECKED)
	{
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RECVFILE),TRUE);
		EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RECVFILE),TRUE);
	}
	EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
}
void
DisableButton(
	HWND	hDlg
)
{
//	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_SENDFILE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_SENDFILE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_SENDSTART),FALSE);
//	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RECVFILE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RECVFILE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RECVSTART),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_CHECK_SAVE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDOK),FALSE);
}
void
SaveFileThreadMain(
	void	*context
)
{
	THREADARG	*arg=(THREADARG*)context;
	FILE		*fp;
	DWORD		size,i;

	fp=fopen(arg->szFile,"wb");
	if(fp)
	{
		size=0;
		for(i=0;i<arg->bufsize/(_dmasize/2);i++)
		{
			if(arg->stop)
				break;
			fwrite(&arg->tranbuf[size],1,(_dmasize/2),fp);
			size+=(_dmasize/2);
		}
		fclose(fp);
	}
	SetEvent(arg->hEvent);
	PostMessage(arg->hWnd,WM_FILESAVE_STOP,(WPARAM)0,(LPARAM)0);
	_endthread();
}
BOOL
FileOpen(
	HWND	hWnd,
	BYTE	*file
)
{
	OPENFILENAME	ofn;
	INT				iRet;

	memset(file,'\0',MAX_PATH);
	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize		= sizeof(OPENFILENAME);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= "ALL Files (*.*)\0*.*\0";
	ofn.lpstrFile		= file;
	ofn.nMaxFile		= MAX_PATH;
	ofn.Flags			= OFN_HIDEREADONLY;
	ofn.lpstrDefExt		= "*.*";
	iRet = GetOpenFileName(&ofn);
	if( iRet != 0 )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}
void
ChangeFileName(
	BYTE	*file
)
{
	BYTE	szFile[MAX_PATH];
	char	*ptr;
	int		len;

	lstrcpy(szFile,file);
	ptr=strrchr(szFile,'.');
	if(ptr)
		*ptr=(char)NULL;
	len=lstrlen(szFile);
	if(isdigit(szFile[len-1]) && isdigit(szFile[len-2])
		&& isdigit(szFile[len-3]) && isdigit(szFile[len-4]))
	{
		ptr=strrchr(file,'.');
		if(ptr)
			lstrcat(szFile,ptr);
	}
	else
	{
		lstrcat(szFile,"0000");
		ptr=strrchr(file,'.');
		if(ptr)
			lstrcat(szFile,ptr);
	}
	lstrcpy(file,szFile);
}
void
IncFileName(
	BYTE	*file
)
{
	BYTE	szFile[MAX_PATH];
	char	*ptr;
	int		len,num;
	char	work[8];

	lstrcpy(szFile,file);
	ptr=strrchr(szFile,'.');
	if(ptr)
		*ptr=(char)NULL;
	len=lstrlen(szFile);
	work[0]=szFile[len-4];
	work[1]=szFile[len-3];
	work[2]=szFile[len-2];
	work[3]=szFile[len-1];
	work[4]=(char)NULL;
	num=atoi(work)+1;
	szFile[len-4]=(char)NULL;
	wsprintf(work,"%04d",num);
	lstrcat(szFile,work);
	ptr=strrchr(file,'.');
	if(ptr)
		lstrcat(szFile,ptr);
	lstrcpy(file,szFile);
}
int
Check(
	void	*context
)
{
	THREADARG	*arg=(THREADARG*)context;
	int			i;
	DWORD		*ptr=(DWORD*)arg->tranbuf;
	BYTE		work[64];

	for(i=0;i<(int)arg->bufsize/4;i++,ptr++)
	{
		if(*ptr!=(DWORD)cpu_to_be32(i))
		{
			wsprintf(work,"offset:0x%08x",i*4);
			MessageBox(arg->hWnd,"Data is NG.\r\n",work,MB_OK);
			return(FALSE);
		}
	}
	return(TRUE);
}
unsigned long
cpu_to_be32(
	unsigned long	value
)
{
	value=(((value>>0)&0xff)<<24|((value>>8)&0xff)<<16|((value>>16)&0xff)<<8|((value>>24)&0xff)<<0);
	return(value);
}
