/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : guiapp.c

	Function       : gui sample

-------------------------------------------------------------------------------
	[history]
	2011-09-08	Ver 1.00   M.Meguro    VK쐬
	2015-08-10	Ver 1.03   M.Meguro    init@CgpȂ悤ɕύX

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	"PcieLib.h"
#include	"resource.h"
/********************************************/
/**    define								*/
/********************************************/
#define	VER_MSG				"guiapp Ver1.03"
/********************************************/
/**     struct                             **/
/********************************************/
typedef	struct
{
	WORD	VenderID;
	WORD	DeviceID;
	WORD	Command;
	WORD	Status;
	BYTE	RevisionID;
	BYTE	ProgI_F;
	BYTE	SubClassCode;
	BYTE	ClassCode;
	BYTE	CacheLineSize;
	BYTE	LatencyTimer;
	BYTE	HeaderType;
	BYTE	BIST;
	DWORD	BaseAddress[6];
	DWORD	CardBusCISPointer;
	WORD	SubSystemVenderID;
	WORD	SubSystemID;
	DWORD	ExpansionROMBaseAddress;
	DWORD	rsv1[2];
	BYTE	IntteruptLine;
	BYTE	IntteruptPin;
	BYTE	MinGnt;
	BYTE	MaxLat;
	DWORD	DeviceDependent[1008];
}
PCI_CONF,*PPCI_CONF;
//********************************************/
/**     function                           **/
/********************************************/
int	WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPreInst,
	LPSTR		lpszCmdLine,
	int			nCmdShow
);
LRESULT	CALLBACK
DevProc(
	HWND		hDlg,
	UINT		message,
	WPARAM		wParam,
	LPARAM		lParam
);
LRESULT	CALLBACK
MainProc(
	HWND		hDlg,
	UINT		message,
	WPARAM		wParam,
	LPARAM		lParam
);
void
InitMainDialog(
	HWND		hDlg
);
void
ReadBaseAddress(
	HWND		hDlg,
	WPARAM		wParam
);
void
WriteBaseAddress(
	HWND		hDlg,
	WPARAM		wParam
);
void
ReadBuffer(
	HWND		hDlg
);
void
WriteBuffer(
	HWND		hDlg
);
void
Version(
	HWND		hDlg
);
void
SetWinCenter(
	HWND		hDlg
);
DWORD
atoh(
	BYTE*		lpszStr
);
/********************************************/
/**     global                             **/
/********************************************/
HINSTANCE	_hInst;
HANDLE		_hDevice=(HANDLE)INVALID_HANDLE_VALUE;
BYTE		_szConfigBuf[4096];
BYTE		_szConfiguration[64*2048];
BYTE		_szConf0[]= "Vender ID              0000             %04X\r\n";
BYTE		_szConf1[]= "Device ID              0002             %04X\r\n";
BYTE		_szConf2[]= "Command                0004             %04X\r\n";
BYTE		_szConf3[]= "Status                 0006             %04X\r\n";
BYTE		_szConf4[]= "Revision ID            0008             %02X\r\n";
BYTE		_szConf5[]= "Prog I/F               0009             %02X\r\n";
BYTE		_szConf6[]= "Sub Class Code         000A             %02X\r\n";
BYTE		_szConf7[]= "Class Code             000B             %02X\r\n";
BYTE		_szConf8[]= "Cache Line Size        000C             %02X\r\n";
BYTE		_szConf9[]= "Latency Timer          000D             %02X\r\n";
BYTE		_szConf10[]="Header Type            000E             %02X\r\n";
BYTE		_szConf11[]="BIST                   000F             %02X\r\n";
BYTE		_szConf12[]="Base Address 0         0010             %08X\r\n";
BYTE		_szConf13[]="Base Address 1         0014             %08X\r\n";
BYTE		_szConf14[]="Base Address 2         0018             %08X\r\n";
BYTE		_szConf15[]="Base Address 3         001C             %08X\r\n";
BYTE		_szConf16[]="Base Address 4         0020             %08X\r\n";
BYTE		_szConf17[]="Base Address 5         0024             %08X\r\n";
BYTE		_szConf18[]="Card Bus CIS Pointer   0028             %08X\r\n";
BYTE		_szConf19[]="Sub System Vender ID   002C             %04X\r\n";
BYTE		_szConf20[]="Sub System ID          002E             %04X\r\n";
BYTE		_szConf21[]="Expansion Rom Base     0030             %08X\r\n";
BYTE		_szConf22[]="Reserved               0034             %08X\r\n";
BYTE		_szConf23[]="Reserved               0038             %08X\r\n";
BYTE		_szConf24[]="Interrupt Line         003C             %02X\r\n";
BYTE		_szConf25[]="Interrupt Pin          003D             %02X\r\n";
BYTE		_szConf26[]="Min_Gnt                003E             %02X\r\n";
BYTE		_szConf27[]="Max_Lat                003F             %02X\r\n";
BYTE		_szConf28[]="Device Dependent       %04X             %08X\r\n";
int			_dev=0;

int	WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPreInst,
	LPSTR		lpszCmdLine,
	int			nCmdShow
)
{	
	DialogBox(_hInst,"DEVBOX",NULL,(DLGPROC)DevProc);

	_hInst=hInstance;
	_hDevice=Pcie_OpenDevice(_dev);
	if(_hDevice==(HANDLE)INVALID_HANDLE_VALUE)
		MessageBox(NULL,"hCoI[vł܂B","error",MB_OK);
	else
		DialogBox(_hInst,"MAINBOX",NULL,(DLGPROC)MainProc);
	return(0);
}
LRESULT	CALLBACK
DevProc(
	HWND		hDlg,
	UINT		message,
	WPARAM		wParam,
	LPARAM		lParam
)
{
	BYTE			szWork[128];
    switch(message)
	{
		case WM_INITDIALOG:
			SetWinCenter(hDlg);
			SetDlgItemText(hDlg,IDC_EDIT_DEV,"0");
			return (TRUE);
		case WM_COMMAND:					/* R}h󂯎 */
			switch(LOWORD(wParam))
			{
				case ID_EXIT:
				case IDOK:
				case IDCANCEL:
					GetDlgItemText(hDlg,IDC_EDIT_DEV,szWork,sizeof(szWork)-1);
					_dev=atoi(szWork);
					EndDialog(hDlg,TRUE);	/* _CAO{bNX */
					return(TRUE);
			}
			break;
	}
	return(FALSE);							/* bZ[WȂꍇ */
}
LRESULT	CALLBACK
MainProc(
	HWND		hDlg,
	UINT		message,
	WPARAM		wParam,
	LPARAM		lParam
)
{
    switch(message)
	{
		case WM_INITDIALOG:
			InitMainDialog(hDlg);
			return (TRUE);
		case WM_COMMAND:					/* R}h󂯎 */
			switch(LOWORD(wParam))
			{
				case IDC_BUTTONREADBYTE:	// [h
				case IDC_BUTTONREADWORD:
				case IDC_BUTTONREADDWORD:
					ReadBaseAddress(hDlg,wParam);
					return(TRUE);
				case IDC_BUTTONWRITEBYTE:	// Cg
				case IDC_BUTTONWRITEWORD:
				case IDC_BUTTONWRITEDWORD:
					WriteBaseAddress(hDlg,wParam);
					return(TRUE);
				case IDC_BUTTONREADSINGLE:
					ReadBuffer(hDlg);
					return(TRUE);
				case IDC_BUTTONWRITESINGLE:
					WriteBuffer(hDlg);
					return(TRUE);
				case ID_ABOUT:				// o[W\
					Version(hDlg);
					return(TRUE);
				case ID_EXIT:
				case IDOK:
				case IDCANCEL:
					// foCX
					if(_hDevice!=(HANDLE)INVALID_HANDLE_VALUE)
						Pcie_CloseDevice(_hDevice);
					EndDialog(hDlg,TRUE);	/* _CAO{bNX */
					return(TRUE);
			}
			break;
	}
	return(FALSE);							/* bZ[WȂꍇ */
}
#ifndef		GCL_HICON		
#define		GCL_HICON		(-14)			// for 64bit
#endif
void
InitMainDialog(
	HWND		hDlg
)
{
	long			ret;
	PCI_CONF*		pPci;
	BYTE			szWork[128];
	DWORD			i,size;

	for(;;)
	{
		SetWinCenter(hDlg);
		// ݂̐ݒ
		SetClassLongPtr(hDlg,GCL_HICON,(LONG)LoadIcon(_hInst,MAKEINTRESOURCE(IDI_ICON1)));
		wsprintf(szWork,"PCIe Device Driver GUI Sample Application(DeviceNumber=%d)",_dev);
		SetWindowText(hDlg,szWork);

		size=sizeof(_szConfigBuf);
		// PCI Configuration Register Read
		ret=Pcie_ReadPciConfig(_hDevice,size,0,_szConfigBuf);
		if(ret!=(long)PCIE_NORMAL)
		{
			size=256;
			ret=Pcie_ReadPciConfig(_hDevice,size,0,_szConfigBuf);
			if(ret!=(long)PCIE_NORMAL)
			{
				MessageBox(hDlg,"PCI Configuration Register Can not Read","error",MB_ICONSTOP);
				break;
			}
		}

		// Configuration Dataʂɓ\t
		pPci=(PCI_CONF*)_szConfigBuf;
		ZeroMemory(_szConfiguration,sizeof(_szConfiguration));
		wsprintf(szWork,_szConf0,pPci->VenderID);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf1,pPci->DeviceID);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf2,pPci->Command);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf3,pPci->Status);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf4,pPci->RevisionID);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf5,pPci->ProgI_F);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf6,pPci->SubClassCode);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf7,pPci->ClassCode);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf8,pPci->CacheLineSize);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf9,pPci->LatencyTimer);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf10,pPci->HeaderType);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf11,pPci->BIST);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf12,pPci->BaseAddress[0]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf13,pPci->BaseAddress[1]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf14,pPci->BaseAddress[2]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf15,pPci->BaseAddress[3]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf16,pPci->BaseAddress[4]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf17,pPci->BaseAddress[5]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf18,pPci->CardBusCISPointer);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf19,pPci->SubSystemVenderID);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf20,pPci->SubSystemID);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf21,pPci->ExpansionROMBaseAddress);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf22,pPci->rsv1[0]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf23,pPci->rsv1[1]);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf24,pPci->IntteruptLine);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf25,pPci->IntteruptPin);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf26,pPci->MinGnt);
		lstrcat(_szConfiguration,szWork);
		wsprintf(szWork,_szConf27,pPci->MaxLat);
		lstrcat(_szConfiguration,szWork);
		if(size==256)
		{
			// for PCI
			for(i=0;i<48;i++)
			{
				wsprintf(szWork,_szConf28,i*4+0x40,pPci->DeviceDependent[i]);
				lstrcat(_szConfiguration,szWork);
			}
		}
		else
		{
			// for PCIe
			for(i=0;i<1008;i++)
			{
				wsprintf(szWork,_szConf28,i*4+0x40,pPci->DeviceDependent[i]);
				lstrcat(_szConfiguration,szWork);
			}
		}
		SetDlgItemText(hDlg,IDC_EDITPCICONFIG,_szConfiguration);
		break;
	}
}
void
ReadBaseAddress(
	HWND		hDlg,
	WPARAM		wParam
)
{
	long	ret;
	BYTE	szWork[64];
	DWORD	dwValue;
	DWORD	dwOffset;
	DWORD	dwBase;

	for(;;)
	{
		GetDlgItemText(hDlg,IDC_EDITREADBASE,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Base Number","error",MB_ICONSTOP);
			break;
		}
		dwBase=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITREADOFFSET,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Offset","error",MB_ICONSTOP);
			break;
		}
		dwOffset=atoh(szWork);

		switch(LOWORD(wParam))
		{
			case IDC_BUTTONREADBYTE:
				ret=Pcie_ReadRegister8(_hDevice,dwBase,dwOffset,(BYTE*)&dwValue);
				wsprintf(szWork,"%02X",dwValue);
				break;
			case IDC_BUTTONREADWORD:
				ret=Pcie_ReadRegister16(_hDevice,dwBase,dwOffset,(WORD*)&dwValue);
				wsprintf(szWork,"%04X",dwValue);
				break;
			case IDC_BUTTONREADDWORD:
				ret=Pcie_ReadRegister32(_hDevice,dwBase,dwOffset,(DWORD*)&dwValue);
				wsprintf(szWork,"%08X",dwValue);
				break;
		}
		if(ret!=(long)PCIE_NORMAL)
		{
			MessageBox(hDlg,"Read Data Error","error",MB_ICONSTOP);
			break;
		}
		SetDlgItemText(hDlg,IDC_EDITREADDATA,szWork);
		break;
	}
}
void
WriteBaseAddress(
	HWND		hDlg,
	WPARAM		wParam
)
{
	long	ret;
	BYTE	szWork[64];
	DWORD	dwValue;
	DWORD	dwOffset;
	DWORD	dwBase;

	for(;;)
	{
		GetDlgItemText(hDlg,IDC_EDITWRITEBASE,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Base Number","error",MB_ICONSTOP);
			break;
		}
		dwBase=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITWRITEOFFSET,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Offset","error",MB_ICONSTOP);
			break;
		}
		dwOffset=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITWRITEDATA,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Data","error",MB_ICONSTOP);
			break;
		}
		dwValue=atoh(szWork);

		switch(LOWORD(wParam))
		{
			case IDC_BUTTONWRITEBYTE:
				ret=Pcie_WriteRegister8(_hDevice,dwBase,dwOffset,(BYTE)dwValue);
				break;
			case IDC_BUTTONWRITEWORD:
				ret=Pcie_WriteRegister16(_hDevice,dwBase,dwOffset,(WORD)dwValue);
				break;
			case IDC_BUTTONWRITEDWORD:
				ret=Pcie_WriteRegister32(_hDevice,dwBase,dwOffset,(DWORD)dwValue);
				break;
		}
		if(ret!=(long)PCIE_NORMAL)
		{
			MessageBox(hDlg,"Write Data Error","error",MB_ICONSTOP);
			break;
		}
		break;
	}
}
void
ReadBuffer(
	HWND		hDlg
)
{
	long			ret;
	BYTE			szWork[64];
	DWORD			dwOffset;
	DWORD			dwBase;
	DWORD			dwCount;
	BYTE			*lpszBuf=(BYTE*)NULL;
	LARGE_INTEGER	freq,start,end;
	float			fTime,fMbytes,fPer=0;
	BYTE			szMsg[256];
	FILE			*fp;

	QueryPerformanceFrequency(&freq);
	for(;;)
	{
		GetDlgItemText(hDlg,IDC_EDITREADBASE,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Base Number","error",MB_ICONSTOP);
			break;
		}
		dwBase=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITREADOFFSET,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Offset","error",MB_ICONSTOP);
			break;
		}
		dwOffset=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITREADCOUNT,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Count","error",MB_ICONSTOP);
			break;
		}
		dwCount=atoh(szWork);
		if(dwCount%4!=0)
		{
			MessageBox(hDlg,"Count͓]BYTE͂ĉBA4̔{łKv܂","error",MB_ICONSTOP);
			break;
		}

		lpszBuf=VirtualAlloc(NULL,dwCount,MEM_COMMIT,PAGE_READWRITE);
		if(lpszBuf==(BYTE*)NULL)
		{
			MessageBox(hDlg,"[lG[","Error",MB_ICONSTOP);
			break;
		}

		ZeroMemory(lpszBuf,dwCount);
		QueryPerformanceCounter(&start);
		ret=Pcie_ReadBlock(_hDevice,dwBase,dwOffset,dwCount,lpszBuf);
		QueryPerformanceCounter(&end);
		if(ret!=(long)PCIE_NORMAL)
		{
			MessageBox(hDlg,"ReadBuffer Error","error",MB_ICONSTOP);
			break;
		}
		fTime=(float)((end.QuadPart-start.QuadPart)*1000000/freq.QuadPart);
		fMbytes=(float)dwCount/(1024*1024);
		if(fTime)
			fPer=(fMbytes/fTime)*1000*1000;
		sprintf(szMsg,"READ:%ldms %.2fMiB/s",(int)fTime/1000,fPer);
		MessageBox(hDlg,szMsg,"Performance",MB_OK);
		fp=fopen("read_data.bin","wb");
		if(fp)
		{
			fwrite(lpszBuf,1,dwCount,fp);
			fclose(fp);
			MessageBox(hDlg,"read_data.binɃZ[u܂B","OK",MB_OK);
		}
		else
			MessageBox(hDlg,"read_data.binɃZ[uł܂łB","ERROR",MB_OK);
		break;
	}
	if(lpszBuf)
	{
		VirtualFree((LPVOID)lpszBuf,0,MEM_RELEASE);
	}
}
void
WriteBuffer(
	HWND		hDlg
)
{
	long			ret;
	BYTE			szWork[64];
	DWORD			dwValue;
	DWORD			dwOffset;
	DWORD			dwBase;
	DWORD			dwCount;
	DWORD			i,*ptr;
	BYTE			*lpszBuf=(BYTE*)NULL;
	LARGE_INTEGER	freq,start,end;
	float			fTime,fMbytes,fPer=0;
	BYTE			szMsg[256];

	QueryPerformanceFrequency(&freq);
	for(;;)
	{
		GetDlgItemText(hDlg,IDC_EDITWRITEBASE,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Base Number","error",MB_ICONSTOP);
			break;
		}
		dwBase=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITWRITEOFFSET,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Offset","error",MB_ICONSTOP);
			break;
		}
		dwOffset=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITWRITEDATA,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Data","error",MB_ICONSTOP);
			break;
		}
		dwValue=atoh(szWork);

		GetDlgItemText(hDlg,IDC_EDITWRITECOUNT,szWork,sizeof(szWork)-1);
		if(lstrlen(szWork)==0)
		{
			MessageBox(hDlg,"Input Count","error",MB_ICONSTOP);
			break;
		}
		dwCount=atoh(szWork);
		if(dwCount%4!=0)
		{
			MessageBox(hDlg,"Count͓]BYTE͂ĉBA4̔{łKv܂","error",MB_ICONSTOP);
			break;
		}

		lpszBuf=VirtualAlloc(NULL,dwCount,MEM_COMMIT,PAGE_READWRITE);
		if(lpszBuf==(BYTE*)NULL)
		{
			MessageBox(hDlg,"[lG[","Error",MB_ICONSTOP);
			break;
		}

		// f[^쐬
		for(i=0,ptr=(DWORD*)lpszBuf;i<dwCount/4;i++,ptr++)
		{
			*ptr=dwValue++;
		}

		QueryPerformanceCounter(&start);
		ret=Pcie_WriteBlock(_hDevice,dwBase,dwOffset,dwCount,lpszBuf);
		QueryPerformanceCounter(&end);
		if(ret!=(long)PCIE_NORMAL)
		{
			MessageBox(hDlg,"WriteBuffer Error","error",MB_ICONSTOP);
			break;
		}
		fTime=(float)((end.QuadPart-start.QuadPart)*1000000/freq.QuadPart);
		fMbytes=(float)dwCount/(1024*1024);
		if(fTime)
			fPer=(fMbytes/fTime)*1000*1000;
		sprintf(szMsg,"32bitCNgf[^݂܂B\nWRITE:%ldms %.2fMiB/s",(int)fTime/1000,fPer);
		MessageBox(hDlg,szMsg,"Performance",MB_OK);
		break;
	}
	if(lpszBuf)
	{
		VirtualFree((LPVOID)lpszBuf,0,MEM_RELEASE);
	}
}

void
Version(
	HWND		hDlg
)
{
	// o[W\
	ShellAbout(hDlg,
			VER_MSG,
			"Copyright (C) Skywave CO.,LTD",NULL);
}
void
SetWinCenter(
	HWND		hDlg
)
{
	HWND	hDeskWnd;
	RECT	deskrc,rc;
	int		x,y;
    
	hDeskWnd=GetDesktopWindow();
	GetWindowRect(hDeskWnd,(LPRECT)&deskrc);
	GetWindowRect(hDlg,(LPRECT)&rc);
	x=(deskrc.right-(rc.right-rc.left))/2;
	y=(deskrc.bottom-(rc.bottom-rc.top))/2;
	SetWindowPos(hDlg,HWND_TOP,x,y,(rc.right-rc.left),(rc.bottom-rc.top),SWP_SHOWWINDOW); 
}
DWORD
atoh(
	BYTE*		lpszStr
)
{
	DWORD	n;

	for(n=0;*lpszStr!=(BYTE)NULL;lpszStr++)
	{
		n*=(DWORD)16;
		if(*lpszStr>='0' && *lpszStr<='9')
			n+=(*lpszStr-'0');
		else if(*lpszStr>='A' && *lpszStr<='F')
			n+=(*lpszStr-'A'+10);
		else if(*lpszStr>='a' && *lpszStr<='f')
			n+=(*lpszStr-'a'+10);
		else
			break;
	}
	return(n);
}
