/*******************************************************************************

	Project        : PCI express

	Component      : sample app

	Module         : readreg.c

	Function       : read register

-------------------------------------------------------------------------------
	[history]
	09-27-2010	Ver 1.00   M.Meguro    create
	07-09-2015	Ver	1.03   Y.Watanabe  device number is input by a command line argument

******************************************************************************/
//*******************************************/
//*    include								*/
//*******************************************/
#include	<stdlib.h>
#include	"pcielib.h"

int
main(
	int		argc,
	char	*argv[]
)
{
	HANDLE	hDevice;
	int		ret;
	int		devnum;
	char	*stopstring;
	DWORD	bar;
	DWORD	offset;
	DWORD	type;
	DWORD	value=0;

	if(argc!=5)
	{
		printf("Usage:\n");
		printf("\treadreg [device number] [address space] [offset] [type]\n");
		printf("\tdevice number:device number functions\n");
		printf("\taddress space:base address number\n");
		printf("\toffset:register offset\n");
		printf("\ttype:access type(0:32bit 1:16bit 2:8bit)\n");
		exit(0);
	}
	devnum=strtol(argv[1],&stopstring,0);
	hDevice=Pcie_OpenDevice(devnum);
	if(hDevice!=INVALID_HANDLE_VALUE)
	{
		bar=strtol(argv[2],&stopstring,0);
		offset=strtol(argv[3],&stopstring,0);
		type=strtol(argv[4],&stopstring,0);
		if(type==1)
			ret=Pcie_ReadRegister16(hDevice,bar,offset,(WORD*)&value);
		else if(type==2)
			ret=Pcie_ReadRegister8(hDevice,bar,offset,(BYTE*)&value);
		else
			ret=Pcie_ReadRegister32(hDevice,bar,offset,&value);
		if(ret!=PCIE_NORMAL)
			printf("Pcie_ReadRegister error=%d\n",ret);
		else
			printf("0x%08X:0x%08X\n",offset,value);
	}
	else
		printf("driver open error\n");
	if(hDevice!=INVALID_HANDLE_VALUE)
		Pcie_CloseDevice(hDevice);
	return(0);
}
